// This file is generated by kconfig_compiler_kf5 from touchpad.kcfg.
// All changes you do to this file will be lost.
#ifndef TOUCHPADPARAMETERS_H
#define TOUCHPADPARAMETERS_H

#include "kcm/touchpadparametersbase.h"

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class TouchpadParameters : public TouchpadParametersBase
{
  public:
    enum Button { NoButton, LeftButton, MiddleButton, RightButton };
    enum EnumTapAction { OneFingerTap, TwoFingerTap, ThreeFingerTap, LTCorner, LBCorner, RTCorner, RBCorner };
    static const char* const EnumTapActionToString[];
    enum Edge { AllEdges, TopEdge, TopRightCorner, RightEdge, BottomRightCorner, BottomEdge, BottomLeftCorner, LeftEdge, TopLeftCorner };

    TouchpadParameters( );
    ~TouchpadParameters();

    /**
      Set Tapping
    */
    void setTapping( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "Tapping" ) ))
        mTapping = v;
    }

    /**
      Get Tapping
    */
    bool tapping() const
    {
      return mTapping;
    }

    /**
      Set $(TapAction)Button
    */
    void setButton( int i, Button v )
    {
      if (!isImmutable( QString::fromLatin1( "%1Button" ).arg( QLatin1String( EnumTapActionToString[i] ) ) ))
        mButton[i] = v;
    }

    /**
      Get $(TapAction)Button
    */
    Button button( int i ) const
    {
      return static_cast<Button>(mButton[i]);
    }

    /**
      Set VertEdgeScroll
    */
    void setVertEdgeScroll( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "VertEdgeScroll" ) ))
        mVertEdgeScroll = v;
    }

    /**
      Get VertEdgeScroll
    */
    bool vertEdgeScroll() const
    {
      return mVertEdgeScroll;
    }

    /**
      Set VertTwoFingerScroll
    */
    void setVertTwoFingerScroll( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "VertTwoFingerScroll" ) ))
        mVertTwoFingerScroll = v;
    }

    /**
      Get VertTwoFingerScroll
    */
    bool vertTwoFingerScroll() const
    {
      return mVertTwoFingerScroll;
    }

    /**
      Set HorizEdgeScroll
    */
    void setHorizEdgeScroll( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "HorizEdgeScroll" ) ))
        mHorizEdgeScroll = v;
    }

    /**
      Get HorizEdgeScroll
    */
    bool horizEdgeScroll() const
    {
      return mHorizEdgeScroll;
    }

    /**
      Set HorizTwoFingerScroll
    */
    void setHorizTwoFingerScroll( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "HorizTwoFingerScroll" ) ))
        mHorizTwoFingerScroll = v;
    }

    /**
      Get HorizTwoFingerScroll
    */
    bool horizTwoFingerScroll() const
    {
      return mHorizTwoFingerScroll;
    }

    /**
      Set MinSpeed
    */
    void setMinSpeed( double v )
    {
      if (v < 0)
      {
        qDebug() << "setMinSpeed: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 255)
      {
        qDebug() << "setMinSpeed: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "MinSpeed" ) ))
        mMinSpeed = v;
    }

    /**
      Get MinSpeed
    */
    double minSpeed() const
    {
      return mMinSpeed;
    }

    /**
      Set MaxSpeed
    */
    void setMaxSpeed( double v )
    {
      if (v < 0)
      {
        qDebug() << "setMaxSpeed: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 255)
      {
        qDebug() << "setMaxSpeed: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "MaxSpeed" ) ))
        mMaxSpeed = v;
    }

    /**
      Get MaxSpeed
    */
    double maxSpeed() const
    {
      return mMaxSpeed;
    }

    /**
      Set AccelFactor
    */
    void setAccelFactor( double v )
    {
      if (v < 0)
      {
        qDebug() << "setAccelFactor: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 1)
      {
        qDebug() << "setAccelFactor: value " << v << " is greater than the maximum value of 1";
        v = 1;
      }

      if (!isImmutable( QString::fromLatin1( "AccelFactor" ) ))
        mAccelFactor = v;
    }

    /**
      Get AccelFactor
    */
    double accelFactor() const
    {
      return mAccelFactor;
    }

    /**
      Set HorizHysteresis
    */
    void setHorizHysteresis( int v )
    {
      if (v < 0)
      {
        qDebug() << "setHorizHysteresis: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 100)
      {
        qDebug() << "setHorizHysteresis: value " << v << " is greater than the maximum value of 100";
        v = 100;
      }

      if (!isImmutable( QString::fromLatin1( "HorizHysteresis" ) ))
        mHorizHysteresis = v;
    }

    /**
      Get HorizHysteresis
    */
    int horizHysteresis() const
    {
      return mHorizHysteresis;
    }

    /**
      Set VertHysteresis
    */
    void setVertHysteresis( int v )
    {
      if (v < 0)
      {
        qDebug() << "setVertHysteresis: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 100)
      {
        qDebug() << "setVertHysteresis: value " << v << " is greater than the maximum value of 100";
        v = 100;
      }

      if (!isImmutable( QString::fromLatin1( "VertHysteresis" ) ))
        mVertHysteresis = v;
    }

    /**
      Get VertHysteresis
    */
    int vertHysteresis() const
    {
      return mVertHysteresis;
    }

    /**
      Set TapAndDragGesture
    */
    void setTapAndDragGesture( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "TapAndDragGesture" ) ))
        mTapAndDragGesture = v;
    }

    /**
      Get TapAndDragGesture
    */
    bool tapAndDragGesture() const
    {
      return mTapAndDragGesture;
    }

    /**
      Set LockedDrags
    */
    void setLockedDrags( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "LockedDrags" ) ))
        mLockedDrags = v;
    }

    /**
      Get LockedDrags
    */
    bool lockedDrags() const
    {
      return mLockedDrags;
    }

    /**
      Set LockedDragTimeout
    */
    void setLockedDragTimeout( int v )
    {
      if (v < 0)
      {
        qDebug() << "setLockedDragTimeout: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 30000)
      {
        qDebug() << "setLockedDragTimeout: value " << v << " is greater than the maximum value of 30000";
        v = 30000;
      }

      if (!isImmutable( QString::fromLatin1( "LockedDragTimeout" ) ))
        mLockedDragTimeout = v;
    }

    /**
      Get LockedDragTimeout
    */
    int lockedDragTimeout() const
    {
      return mLockedDragTimeout;
    }

    /**
      Set VertScrollDelta
    */
    void setVertScrollDelta( double v )
    {
      if (v < 0)
      {
        qDebug() << "setVertScrollDelta: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 10)
      {
        qDebug() << "setVertScrollDelta: value " << v << " is greater than the maximum value of 10";
        v = 10;
      }

      if (!isImmutable( QString::fromLatin1( "VertScrollDelta" ) ))
        mVertScrollDelta = v;
    }

    /**
      Get VertScrollDelta
    */
    double vertScrollDelta() const
    {
      return mVertScrollDelta;
    }

    /**
      Set InvertVertScroll
    */
    void setInvertVertScroll( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "InvertVertScroll" ) ))
        mInvertVertScroll = v;
    }

    /**
      Get InvertVertScroll
    */
    bool invertVertScroll() const
    {
      return mInvertVertScroll;
    }

    /**
      Set HorizScrollDelta
    */
    void setHorizScrollDelta( double v )
    {
      if (v < 0)
      {
        qDebug() << "setHorizScrollDelta: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 10)
      {
        qDebug() << "setHorizScrollDelta: value " << v << " is greater than the maximum value of 10";
        v = 10;
      }

      if (!isImmutable( QString::fromLatin1( "HorizScrollDelta" ) ))
        mHorizScrollDelta = v;
    }

    /**
      Get HorizScrollDelta
    */
    double horizScrollDelta() const
    {
      return mHorizScrollDelta;
    }

    /**
      Set InvertHorizScroll
    */
    void setInvertHorizScroll( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "InvertHorizScroll" ) ))
        mInvertHorizScroll = v;
    }

    /**
      Get InvertHorizScroll
    */
    bool invertHorizScroll() const
    {
      return mInvertHorizScroll;
    }

    /**
      Set CornerCoasting
    */
    void setCornerCoasting( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CornerCoasting" ) ))
        mCornerCoasting = v;
    }

    /**
      Get CornerCoasting
    */
    bool cornerCoasting() const
    {
      return mCornerCoasting;
    }

    /**
      Set CoastingSpeed
    */
    void setCoastingSpeed( double v )
    {
      if (v < 0.1)
      {
        qDebug() << "setCoastingSpeed: value " << v << " is less than the minimum value of 0.1";
        v = 0.1;
      }

      if (v > 255)
      {
        qDebug() << "setCoastingSpeed: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "CoastingSpeed" ) ))
        mCoastingSpeed = v;
    }

    /**
      Get CoastingSpeed
    */
    double coastingSpeed() const
    {
      return mCoastingSpeed;
    }

    /**
      Set CoastingFriction
    */
    void setCoastingFriction( double v )
    {
      if (v < 0)
      {
        qDebug() << "setCoastingFriction: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 255)
      {
        qDebug() << "setCoastingFriction: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "CoastingFriction" ) ))
        mCoastingFriction = v;
    }

    /**
      Get CoastingFriction
    */
    double coastingFriction() const
    {
      return mCoastingFriction;
    }

    /**
      Set Coasting
    */
    void setCoasting( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "Coasting" ) ))
        mCoasting = v;
    }

    /**
      Get Coasting
    */
    bool coasting() const
    {
      return mCoasting;
    }

    /**
      Set FingerHigh
    */
    void setFingerHigh( int v )
    {
      if (v < 0)
      {
        qDebug() << "setFingerHigh: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 255)
      {
        qDebug() << "setFingerHigh: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "FingerHigh" ) ))
        mFingerHigh = v;
    }

    /**
      Get FingerHigh
    */
    int fingerHigh() const
    {
      return mFingerHigh;
    }

    /**
      Set FingerLow
    */
    void setFingerLow( int v )
    {
      if (v < 0)
      {
        qDebug() << "setFingerLow: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 255)
      {
        qDebug() << "setFingerLow: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "FingerLow" ) ))
        mFingerLow = v;
    }

    /**
      Get FingerLow
    */
    int fingerLow() const
    {
      return mFingerLow;
    }

    /**
      Set PalmDetect
    */
    void setPalmDetect( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "PalmDetect" ) ))
        mPalmDetect = v;
    }

    /**
      Get PalmDetect
    */
    bool palmDetect() const
    {
      return mPalmDetect;
    }

    /**
      Set PalmMinZ
    */
    void setPalmMinZ( int v )
    {
      if (v < 0)
      {
        qDebug() << "setPalmMinZ: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 255)
      {
        qDebug() << "setPalmMinZ: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "PalmMinZ" ) ))
        mPalmMinZ = v;
    }

    /**
      Get PalmMinZ
    */
    int palmMinZ() const
    {
      return mPalmMinZ;
    }

    /**
      Set PalmMinWidth
    */
    void setPalmMinWidth( int v )
    {
      if (v < 0)
      {
        qDebug() << "setPalmMinWidth: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 15)
      {
        qDebug() << "setPalmMinWidth: value " << v << " is greater than the maximum value of 15";
        v = 15;
      }

      if (!isImmutable( QString::fromLatin1( "PalmMinWidth" ) ))
        mPalmMinWidth = v;
    }

    /**
      Get PalmMinWidth
    */
    int palmMinWidth() const
    {
      return mPalmMinWidth;
    }

    /**
      Set MaxTapTime
    */
    void setMaxTapTime( int v )
    {
      if (v < 0)
      {
        qDebug() << "setMaxTapTime: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 1000)
      {
        qDebug() << "setMaxTapTime: value " << v << " is greater than the maximum value of 1000";
        v = 1000;
      }

      if (!isImmutable( QString::fromLatin1( "MaxTapTime" ) ))
        mMaxTapTime = v;
    }

    /**
      Get MaxTapTime
    */
    int maxTapTime() const
    {
      return mMaxTapTime;
    }

    /**
      Set MaxDoubleTapTime
    */
    void setMaxDoubleTapTime( int v )
    {
      if (v < 0)
      {
        qDebug() << "setMaxDoubleTapTime: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 1000)
      {
        qDebug() << "setMaxDoubleTapTime: value " << v << " is greater than the maximum value of 1000";
        v = 1000;
      }

      if (!isImmutable( QString::fromLatin1( "MaxDoubleTapTime" ) ))
        mMaxDoubleTapTime = v;
    }

    /**
      Get MaxDoubleTapTime
    */
    int maxDoubleTapTime() const
    {
      return mMaxDoubleTapTime;
    }

    /**
      Set SingleTapTimeout
    */
    void setSingleTapTimeout( int v )
    {
      if (v < 0)
      {
        qDebug() << "setSingleTapTimeout: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 1000)
      {
        qDebug() << "setSingleTapTimeout: value " << v << " is greater than the maximum value of 1000";
        v = 1000;
      }

      if (!isImmutable( QString::fromLatin1( "SingleTapTimeout" ) ))
        mSingleTapTimeout = v;
    }

    /**
      Get SingleTapTimeout
    */
    int singleTapTimeout() const
    {
      return mSingleTapTimeout;
    }

    /**
      Set MaxTapMove
    */
    void setMaxTapMove( double v )
    {
      if (v < 0)
      {
        qDebug() << "setMaxTapMove: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 20)
      {
        qDebug() << "setMaxTapMove: value " << v << " is greater than the maximum value of 20";
        v = 20;
      }

      if (!isImmutable( QString::fromLatin1( "MaxTapMove" ) ))
        mMaxTapMove = v;
    }

    /**
      Get MaxTapMove
    */
    double maxTapMove() const
    {
      return mMaxTapMove;
    }

    /**
      Set PressureMotionMinZ
    */
    void setPressureMotionMinZ( int v )
    {
      if (v < 1)
      {
        qDebug() << "setPressureMotionMinZ: value " << v << " is less than the minimum value of 1";
        v = 1;
      }

      if (v > 255)
      {
        qDebug() << "setPressureMotionMinZ: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "PressureMotionMinZ" ) ))
        mPressureMotionMinZ = v;
    }

    /**
      Get PressureMotionMinZ
    */
    int pressureMotionMinZ() const
    {
      return mPressureMotionMinZ;
    }

    /**
      Set PressureMotionMaxZ
    */
    void setPressureMotionMaxZ( int v )
    {
      if (v < 1)
      {
        qDebug() << "setPressureMotionMaxZ: value " << v << " is less than the minimum value of 1";
        v = 1;
      }

      if (v > 255)
      {
        qDebug() << "setPressureMotionMaxZ: value " << v << " is greater than the maximum value of 255";
        v = 255;
      }

      if (!isImmutable( QString::fromLatin1( "PressureMotionMaxZ" ) ))
        mPressureMotionMaxZ = v;
    }

    /**
      Get PressureMotionMaxZ
    */
    int pressureMotionMaxZ() const
    {
      return mPressureMotionMaxZ;
    }

    /**
      Set PressureMotionMinFactor
    */
    void setPressureMotionMinFactor( double v )
    {
      if (v < 0)
      {
        qDebug() << "setPressureMotionMinFactor: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 10)
      {
        qDebug() << "setPressureMotionMinFactor: value " << v << " is greater than the maximum value of 10";
        v = 10;
      }

      if (!isImmutable( QString::fromLatin1( "PressureMotionMinFactor" ) ))
        mPressureMotionMinFactor = v;
    }

    /**
      Get PressureMotionMinFactor
    */
    double pressureMotionMinFactor() const
    {
      return mPressureMotionMinFactor;
    }

    /**
      Set PressureMotionMaxFactor
    */
    void setPressureMotionMaxFactor( double v )
    {
      if (v < 0)
      {
        qDebug() << "setPressureMotionMaxFactor: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 10)
      {
        qDebug() << "setPressureMotionMaxFactor: value " << v << " is greater than the maximum value of 10";
        v = 10;
      }

      if (!isImmutable( QString::fromLatin1( "PressureMotionMaxFactor" ) ))
        mPressureMotionMaxFactor = v;
    }

    /**
      Get PressureMotionMaxFactor
    */
    double pressureMotionMaxFactor() const
    {
      return mPressureMotionMaxFactor;
    }

    /**
      Set CircularScrolling
    */
    void setCircularScrolling( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "CircularScrolling" ) ))
        mCircularScrolling = v;
    }

    /**
      Get CircularScrolling
    */
    bool circularScrolling() const
    {
      return mCircularScrolling;
    }

    /**
      Set CircScrollDelta
    */
    void setCircScrollDelta( double v )
    {
      if (v < 0)
      {
        qDebug() << "setCircScrollDelta: value " << v << " is less than the minimum value of 0";
        v = 0;
      }

      if (v > 45)
      {
        qDebug() << "setCircScrollDelta: value " << v << " is greater than the maximum value of 45";
        v = 45;
      }

      if (!isImmutable( QString::fromLatin1( "CircScrollDelta" ) ))
        mCircScrollDelta = v;
    }

    /**
      Get CircScrollDelta
    */
    double circScrollDelta() const
    {
      return mCircScrollDelta;
    }

    /**
      Set CircScrollTrigger
    */
    void setCircScrollTrigger( Edge v )
    {
      if (!isImmutable( QString::fromLatin1( "CircScrollTrigger" ) ))
        mCircScrollTrigger = v;
    }

    /**
      Get CircScrollTrigger
    */
    Edge circScrollTrigger() const
    {
      return static_cast<Edge>(mCircScrollTrigger);
    }

  protected:

    // parameters
    bool mTapping;
    int mButton[7];
    bool mVertEdgeScroll;
    bool mVertTwoFingerScroll;
    bool mHorizEdgeScroll;
    bool mHorizTwoFingerScroll;
    double mMinSpeed;
    double mMaxSpeed;
    double mAccelFactor;
    int mHorizHysteresis;
    int mVertHysteresis;
    bool mTapAndDragGesture;
    bool mLockedDrags;
    int mLockedDragTimeout;
    double mVertScrollDelta;
    bool mInvertVertScroll;
    double mHorizScrollDelta;
    bool mInvertHorizScroll;
    bool mCornerCoasting;
    double mCoastingSpeed;
    double mCoastingFriction;
    bool mCoasting;
    int mFingerHigh;
    int mFingerLow;
    bool mPalmDetect;
    int mPalmMinZ;
    int mPalmMinWidth;
    int mMaxTapTime;
    int mMaxDoubleTapTime;
    int mSingleTapTimeout;
    double mMaxTapMove;
    int mPressureMotionMinZ;
    int mPressureMotionMaxZ;
    double mPressureMotionMinFactor;
    double mPressureMotionMaxFactor;
    bool mCircularScrolling;
    double mCircScrollDelta;
    int mCircScrollTrigger;

  private:
};

#endif

